// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ImageEnIO.pas' rev: 3.00

#ifndef ImageEnIOHPP
#define ImageEnIOHPP
#include <ImageEnProc.hpp>
#include <ImageEnView.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Imageenio
{
//-- type declarations -------------------------------------------------------
struct TGifInfo
{
	Word PosX;
	Word PosY;
	Word Width;
	Word Height;
	Word DelayTime;
	bool FlagTranspColor;
	Imageenproc::TRGB TranspColor;
	bool Interlaced;
} ;

typedef TGifInfo *pGifInfo;

struct TGlobGifInfo
{
	Word WinWidth;
	Word WinHeight;
	Imageenproc::TRGB Background;
	Byte Ratio;
} ;

#pragma pack(push, 1)
struct TGifHeader
{
	char id[6];
	Word WinWidth;
	Word WinHeight;
	Byte Flags;
	Byte Background;
	Byte Ratio;
} ;
#pragma pack(pop)

struct TJpegHeader
{
	Word SOImarker;
	Word APPOmarker;
	Word Len;
	char Id[5];
} ;

struct TStreamJpegHeader
{
	char ID[5];
	int dim;
} ;

struct PCXSHead
{
	char ID[5];
	int dim;
} ;

class DELPHICLASS TImageEnIO;
class PASCALIMPLEMENTATION TImageEnIO : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Graphics::TBitmap* fBitmap;
	Imageenview::TImageEnView* fImageEnView;
	Graphics::TColor fBackground;
	bool fUseLZW;
	void __fastcall SetAttachedBitmap(Graphics::TBitmap* atBitmap);
	void __fastcall SetAttachedImageEn(Imageenview::TImageEnView* atImageEn);
	Graphics::TColor __fastcall GetReBackground(void);
	void __fastcall SetReBackground(Graphics::TColor v);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TImageEnIO(Classes::TComponent* Owner);
	__fastcall virtual ~TImageEnIO(void);
	__property Graphics::TBitmap* AttachedBitmap = {read=fBitmap, write=SetAttachedBitmap};
	void __fastcall Update(void);
	void __fastcall SaveToFileJpeg(const System::AnsiString nf, int Quality);
	void __fastcall LoadFromFileJpeg(const System::AnsiString nf);
	void __fastcall SaveToStreamJpeg(Classes::TStream* Stream, int Quality);
	void __fastcall LoadFromStreamJpeg(Classes::TStream* Stream);
	int __fastcall LoadFromFileGif(const System::AnsiString nf, int idx, TGifInfo &GifInfo, TGlobGifInfo 
		&GlobGifInfo);
	void __fastcall SaveToFileGif(const System::AnsiString nf, bool interlaced, Word DelayTime, bool TranspBack
		, int xpos, int ypos);
	int __fastcall InsertToGif(const System::AnsiString nf, bool interlaced, int idx, Word DelayTime, bool 
		TranspBack, int xpos, int ypos, int winwidth, int winheight);
	/*         class method */ static int __fastcall DeleteGifIm(System::TMetaClass* vmt, const System::AnsiString 
		nf, int idx);
	/*         class method */ static int __fastcall EnumGifIm(System::TMetaClass* vmt, const System::AnsiString 
		nf);
	/*         class method */ static bool __fastcall CheckAniGif(System::TMetaClass* vmt, const System::AnsiString 
		nf);
	int __fastcall LoadFromFileTIFF(System::AnsiString nf, int idx);
	int __fastcall LoadFromStreamGif(Classes::TStream* Stream, int idx, TGifInfo &GifInfo, TGlobGifInfo 
		&GlobGifInfo);
	void __fastcall SaveToStreamGif(Classes::TStream* Stream, bool interlaced, Word DelayTime, bool TranspBack
		, int xpos, int ypos);
	void __fastcall SaveToStreamPCX(Classes::TStream* Stream);
	void __fastcall LoadFromStreamPCX(Classes::TStream* Stream);
	int __fastcall LoadFromStreamTIFF(Classes::TStream* Stream, int idx);
	void __fastcall SaveToStreamBMP(Classes::TStream* Stream);
	void __fastcall LoadFromStreamBMP(Classes::TStream* Stream);
	void __fastcall SaveToFileBMP(const System::AnsiString nf);
	void __fastcall LoadFromFileBMP(const System::AnsiString nf);
	void __fastcall LoadFromFile(const System::AnsiString nf);
	void __fastcall SaveToFile(const System::AnsiString nf);
	bool __fastcall Acquire(void);
	void __fastcall SelectAcquireSource(void);
	
__published:
	__property Imageenview::TImageEnView* AttachedImageEn = {read=fImageEnView, write=SetAttachedImageEn
		};
	__property Graphics::TColor Background = {read=GetReBackground, write=SetReBackground, default=0};
	__property bool UseLZW = {read=fUseLZW, write=fUseLZW, default=0};
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Imageenio */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Imageenio;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// ImageEnIO
